Merge pull request #187 from mpalmer/prereq-resources
[discourse_docker.git] / launcher
1 #!/bin/bash
2
3 command=$1
4 config=$2
5 opt=$3
6
7 # Docker doesn't like uppercase characters, spaces or special characters, catch it now before we build everything out and then find out
8 re='[A-Z/ !@#$%^&*()+~`=]'
9 if [[ $config =~ $re ]];
10 then
11 echo
12 echo "ERROR: Config name must not contain upper case characters, spaces or special characters. Correct config name and rerun $0."
13 echo
14 exit 1
15 fi
16
17 cd "$(dirname "$0")"
18
19 docker_min_version='1.2.0'
20 docker_rec_version='1.2.0'
21
22 config_file=containers/"$config".yml
23 cidbootstrap=cids/"$config"_bootstrap.cid
24 local_discourse=local_discourse
25 image=samsaffron/discourse:1.0.12
26 docker_path=`which docker.io || which docker`
27
28 if [ "${SUPERVISED}" = "true" ]; then
29 restart_policy="--restart=no"
30 attach_on_start="-a"
31 attach_on_run="-a stdout -a stderr"
32 else
33 attach_on_run="-d"
34 fi
35
36 if [ -n "$DOCKER_HOST" ]; then
37 docker_ip=`sed -e 's/^tcp:\/\/\(.*\):.*$/\1/' <<< "$DOCKER_HOST"`
38 elif [ -x "$(which ip 2>/dev/null)" ]; then
39 docker_ip=`ip addr show docker0 | \
40 grep 'inet ' | \
41 awk '{ split($2,a,"/"); print a[1] }';`
42 else
43 docker_ip=`ifconfig | \
44 grep -B1 "inet addr" | \
45 awk '{ if ( $1 == "inet" ) { print $2 } else if ( $2 == "Link" ) { printf "%s:" ,$1 } }' | \
46 grep docker0 | \
47 awk -F: '{ print $3 }';`
48 fi
49
50
51 usage () {
52 echo "Usage: launcher COMMAND CONFIG [--skip-prereqs]"
53 echo "Commands:"
54 echo " start: Start/initialize a container"
55 echo " stop: Stop a running container"
56 echo " restart: Restart a container"
57 echo " destroy: Stop and remove a container"
58 echo " enter: Use nsenter to enter a container"
59 echo " ssh: Start a bash shell in a running container"
60 echo " logs: Docker logs for container"
61 echo " bootstrap: Bootstrap a container for the config based on a template"
62 echo " rebuild: Rebuild a container (destroy old, bootstrap, start new)"
63 echo " cleanup: Remove all containers that have stopped for > 24 hours"
64 echo
65 echo "Options:"
66 echo " --skip-prereqs Don't check prerequisites"
67 echo " --docker-args Extra arguments to pass when running docker"
68 exit 1
69 }
70
71 compare_version() {
72 declare -a ver_a
73 declare -a ver_b
74 IFS=. read -a ver_a <<< "$1"
75 IFS=. read -a ver_b <<< "$2"
76
77 while [[ -n $ver_a ]]; do
78 if (( ver_a > ver_b )); then
79 return 0
80 elif (( ver_b > ver_a )); then
81 return 1
82 else
83 unset ver_a[0]
84 ver_a=("${ver_a[@]}")
85 unset ver_b[0]
86 ver_b=("${ver_b[@]}")
87 fi
88 done
89 return 1 # They are equal
90 }
91
92 prereqs() {
93
94 # 1. docker daemon running?
95 # we send stderr to /dev/null cause we don't care about warnings,
96 # it usually complains about swap which does not matter
97 test=`$docker_path info 2> /dev/null`
98
99 if [[ $? -ne 0 ]] ; then
100 echo "Cannot connect to the docker daemon - verify it is running and you have access"
101 exit 1
102 fi
103
104 # 2. running aufs or btrfs
105 test=`$docker_path info 2> /dev/null | grep 'Driver: '`
106 if [[ "$test" =~ [aufs|btrfs|zfs|overlay] ]] ; then : ; else
107 echo "Your Docker installation is not using a supported filesystem if we were to proceed you may have a broken install."
108 echo "aufs is the recommended filesystem you should be using (zfs/btrfs and overlay may work as well)"
109 echo "You can tell what filesystem you are using by running \"docker info\" and looking at the driver"
110 echo ""
111 echo "If you wish to continue anyway using your existing unsupported filesystem"
112 echo "read the source code of launcher and figure out how to bypass this."
113 exit 1
114 fi
115
116 # 3. running recommended docker version
117 test=($($docker_path --version)) # Get docker version string
118 test=${test[2]//,/} # Get version alone and strip comma if exists
119
120 [[ "$test" =~ "0.12.0" ]] && echo "You are running a broken version of Docker, please upgrade ASAP. See: https://meta.discourse.org/t/the-installation-stopped-in-the-middle/16311/ for more details." && exit 1
121
122 # At least minimum version
123 if compare_version "${docker_min_version}" "${test}"; then
124 echo "ERROR: Docker version ${test} not supported, please upgrade to at least ${docker_min_version}, or recommended ${docker_rec_version}"
125 exit 1
126 fi
127
128 # Recommend best version
129 if compare_version "${docker_rec_version}" "${test}"; then
130 echo "WARNING: Docker version ${test} deprecated, recommend upgrade to ${docker_rec_version} or newer."
131 fi
132
133 # 4. discourse docker image is downloaded
134 test=`$docker_path images | awk '{print $1 ":" $2 }' | grep "$image"`
135
136 if [ -z "$test" ]; then
137 echo
138 echo "WARNING: We are about to start downloading the Discourse base image"
139 echo "This process may take anywhere between a few minutes to an hour, depending on your network speed"
140 echo
141 echo "Please be patient"
142 echo
143
144 fi
145
146 # 5. able to attach stderr / out / tty
147 test=`$docker_path run $user_args -i --rm -a stdout -a stderr $image echo working`
148 if [[ "$test" =~ "working" ]] ; then : ; else
149 echo "Your Docker installation is not working correctly"
150 echo
151 echo "See: https://meta.discourse.org/t/docker-error-on-bootstrap/13657/18?u=sam"
152 exit 1
153 fi
154
155 # 6. sufficient available resources
156 # 6a. Memory
157 free_mem="$(LANG=C free -m | grep 'buffers/cache' | awk '{print $4}')"
158 if [ "$free_mem" -lt 800 ]; then
159 echo "You do not appear to have sufficient memory to run Discourse."
160 echo
161 echo "See https://github.com/discourse/discourse/blob/master/docs/INSTALL-cloud.md#create-new-cloud-server"
162 exit 1
163 elif [ "$free_mem" -lt 1800 ]; then
164 total_swap="$(LANG=C free -m | grep ^Swap: | awk '{print $2}')"
165 if [ "$total_swap" -lt 1000 ]; then
166 echo "You must have at least 1GB of swap when running in a low-memory environment."
167 echo
168 echo "See https://github.com/discourse/discourse/blob/master/docs/INSTALL-cloud.md#set-up-swap-if-needed"
169 exit 1
170 fi
171 fi
172
173 # 6b. Disk space
174 free_disk="$(df /var | tail -n 1 | awk '{print $4}')"
175 if [ "$free_disk" -lt 5000 ]; then
176 echo "You must have at least 5GB of *free* disk space to install Discourse."
177 echo
178 echo "Please free up some space, or expand your disk, before continuing."
179 exit 1
180 fi
181 }
182
183 if [ "$opt" != "--skip-prereqs" ] ; then
184 prereqs
185 fi
186
187 if [ "$opt" == "--docker-args" ] ; then
188 user_args=$4
189 else
190 user_args=""
191 fi
192
193 get_ssh_pub_key() {
194 local ${ssh_key_locations}
195 ssh_key_locations=(
196 ~/.ssh/id_ed25519.pub
197 ~/.ssh/id_ecdsa.pub
198 ~/.ssh/id_rsa.pub
199 ~/.ssh/id_dsa.pub
200 ~core/.ssh/authorized_keys
201 )
202
203 local $keyfile
204 for keyfile in "${ssh_key_locations[@]}"; do
205 if [[ -e ${keyfile} ]] ; then
206 ssh_pub_key="$(cat ${keyfile})"
207 return 0
208 fi
209 done
210
211 return 0
212 }
213
214
215 install_docker() {
216
217 echo "Docker is not installed, you will need to install Docker in order to run Discourse"
218 echo "Please visit https://docs.docker.com/installation/ for instructions on how to do this for your system"
219 echo
220 echo "If you are running Ubuntu Trusty or later, you can try the following:"
221 echo
222
223 echo "sudo apt-key adv --keyserver hkp://p80.pool.sks-keyservers.net:80 --recv-keys 58118E89F3A912897C070ADBF76221572C52609D"
224 echo "sudo sh -c \"echo deb https://apt.dockerproject.org/repo ubuntu-$(lsb_release -sc) main > /etc/apt/sources.list.d/docker.list\""
225 echo "sudo apt-get update"
226 echo "sudo apt-get install docker-engine"
227
228 exit 1
229 }
230
231 host_run() {
232 read -r -d '' env_ruby << 'RUBY'
233 require 'yaml'
234
235 input = STDIN.readlines.join
236 yaml = YAML.load(input)
237
238 if host_run = yaml['host_run']
239 params = yaml['params'] || {}
240 host_run.each do |run|
241 params.each do |k,v|
242 run = run.gsub("$#{k}", v)
243 end
244 STDOUT.write "#{run}--SEP--"
245 end
246 end
247 RUBY
248
249 host_run=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e "$env_ruby"`
250
251 while [ "$host_run" ] ; do
252 iter=${host_run%%--SEP--*}
253 echo
254 echo "Host run: $iter"
255 $iter || exit 1
256 echo
257 host_run="${host_run#*--SEP--}"
258 done
259 }
260
261
262 set_volumes() {
263 volumes=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
264 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['volumes'].map{|v| '-v ' << v['volume']['host'] << ':' << v['volume']['guest'] << ' '}.join"`
265 }
266
267 set_links() {
268 links=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
269 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['links'].map{|l| '--link ' << l['link']['name'] << ':' << l['link']['alias'] << ' '}.join"`
270 }
271
272 set_template_info() {
273
274 templates=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
275 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['templates']"`
276
277
278 arrTemplates=(${templates// / })
279 config_data=$(cat $config_file)
280
281 input="hack: true"
282
283
284 for template in "${arrTemplates[@]}"
285 do
286 [ ! -z $template ] && {
287 input="$input _FILE_SEPERATOR_ $(cat $template)"
288 }
289 done
290
291 # we always want our config file last so it takes priority
292 input="$input _FILE_SEPERATOR_ $config_data"
293
294 read -r -d '' env_ruby << 'RUBY'
295 require 'yaml'
296
297 input=STDIN.readlines.join
298 # default to UTF-8 for the dbs sake
299 env = {'LANG' => 'en_US.UTF-8'}
300 input.split('_FILE_SEPERATOR_').each do |yml|
301 yml.strip!
302 begin
303 env.merge!(YAML.load(yml)['env'] || {})
304 rescue Psych::SyntaxError => e
305 puts e
306 puts "*ERROR."
307 rescue => e
308 puts yml
309 p e
310 end
311 end
312 puts env.map{|k,v| "-e\n#{k}=#{v}" }.join("\n")
313 RUBY
314
315 raw=`exec echo "$input" | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e "$env_ruby"`
316
317 env=()
318 ok=1
319 while read i; do
320 if [ "$i" == "*ERROR." ]; then
321 ok=0
322 elif [ -n "$i" ]; then
323 env[${#env[@]}]=$i
324 fi
325 done <<< "$raw"
326
327 if [ "$ok" -ne 1 ]; then
328 echo "${env[@]}"
329 echo "YAML syntax error. Please check your /var/discourse/containers/*.yml config files."
330 exit 1
331 fi
332 }
333
334 [ -z $docker_path ] && {
335 install_docker
336 }
337
338 [ "$command" == "cleanup" ] && {
339 echo
340 echo "The following command will"
341 echo "- Delete all docker images for old containers"
342 echo "- Delete all stopped and orphan containers"
343 echo
344 read -p "Are you sure (Y/n): " -n 1 -r && echo
345 if [[ $REPLY =~ ^[Yy]$ || ! $REPLY ]]
346 then
347 space=$(df /var/lib/docker | awk '{ print $4 }' | grep -v Available)
348 echo "Starting Cleanup (bytes free $space)"
349
350 STATE_DIR=./.gc-state scripts/docker-gc
351
352 space=$(df /var/lib/docker | awk '{ print $4 }' | grep -v Available)
353 echo "Finished Cleanup (bytes free $space)"
354
355 else
356 exit 1
357 fi
358 exit 0
359 }
360
361 [ $# -lt 2 ] && {
362 usage
363 }
364
365 if [ ! -e $config_file ]
366 then
367 echo "Config file was not found, ensure $config_file exists"
368 echo ""
369 echo "Available configs ( `cd containers && ls -dm *.yml | tr -s '\n' ' ' | awk '{ gsub(/\.yml/, ""); print }'`)"
370 exit 1
371 fi
372
373
374 docker_version=($($docker_path --version))
375 docker_version=${test[2]//,/}
376
377 if compare_version "1.2.0" "$docker_version"; then
378 echo "We recommend you upgrade docker, the version you are running has no restart policies, on reboot your container may not start up"
379 restart_policy=""
380 else
381 restart_policy=${restart_policy:---restart=always}
382 fi
383
384 set_existing_container(){
385 existing=`$docker_path ps -a | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
386 }
387
388 run_stop(){
389
390 set_existing_container
391
392 if [ ! -z $existing ]
393 then
394 (
395 set -x
396 $docker_path stop -t 10 $config
397 )
398 else
399 echo "$config was not started !"
400 exit 1
401 fi
402 }
403
404 run_start(){
405
406 existing=`$docker_path ps | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
407 echo $existing
408 if [ ! -z $existing ]
409 then
410 echo "Nothing to do, your container has already started!"
411 exit 1
412 fi
413
414 existing=`$docker_path ps -a | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
415 if [ ! -z $existing ]
416 then
417 echo "starting up existing container"
418 (
419 set -x
420 $docker_path start $config
421 )
422 exit 0
423 fi
424
425 host_run
426 ports=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
427 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['expose'].map{|p| '-p ' << p.to_s << ' '}.join"`
428
429 docker_args=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
430 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['docker_args']"`
431
432 set_template_info
433 set_volumes
434 set_links
435
436 (
437 hostname=`hostname`
438 set -x
439 $docker_path run $user_args $links $attach_on_run $restart_policy "${env[@]}" -h "$hostname-$config" \
440 -e DOCKER_HOST_IP=$docker_ip --name $config -t $ports $volumes $docker_args $local_discourse/$config \
441 /sbin/boot
442
443 )
444 exit 0
445
446 }
447
448 run_bootstrap(){
449
450 host_run
451
452 get_ssh_pub_key
453
454 # Is the image available?
455 # If not, pull it here so the user is aware what's happening.
456 $docker_path history $image >/dev/null 2>&1 || $docker_path pull $image
457
458 set_template_info
459
460 base_image=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
461 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['base_image']"`
462
463 update_pups=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
464 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['update_pups']"`
465
466 if [[ ! X"" = X"$base_image" ]]; then
467 image=$base_image
468 fi
469
470 set_volumes
471 set_links
472
473 rm -f $cidbootstrap
474
475 run_command="cd /pups &&"
476 if [[ ! "false" = $update_pups ]]; then
477 run_command="$run_command git pull &&"
478 fi
479 run_command="$run_command /pups/bin/pups --stdin"
480
481 echo $run_command
482
483 env=("${env[@]}" "-e" "SSH_PUB_KEY=$ssh_pub_key")
484
485 (exec echo "$input" | $docker_path run $user_args $links "${env[@]}" -e DOCKER_HOST_IP=$docker_ip --cidfile $cidbootstrap -i -a stdin -a stdout -a stderr $volumes $image \
486 /bin/bash -c "$run_command") \
487 || ($docker_path rm `cat $cidbootstrap` && rm $cidbootstrap)
488
489 [ ! -e $cidbootstrap ] && echo "** FAILED TO BOOTSTRAP ** please scroll up and look for earlier error messages, there may be more than one" && exit 1
490
491 sleep 5
492
493 $docker_path commit `cat $cidbootstrap` $local_discourse/$config || echo 'FAILED TO COMMIT'
494 $docker_path rm `cat $cidbootstrap` && rm $cidbootstrap
495 }
496
497 case "$command" in
498 bootstrap)
499 run_bootstrap
500 echo "Successfully bootstrapped, to startup use ./launcher start $config"
501 exit 0
502 ;;
503
504 enter)
505 exec $docker_path exec -it $config /bin/bash
506 ;;
507
508 ssh)
509 existing=`$docker_path ps | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
510
511 if [[ ! -z $existing ]]; then
512 address="`$docker_path port $config 22`"
513 split=(${address//:/ })
514 exec ssh -o StrictHostKeyChecking=no root@${split[0]} -p ${split[1]}
515 else
516 echo "$config is not running!"
517 exit 1
518 fi
519 ;;
520
521 stop)
522 run_stop
523 exit 0
524 ;;
525
526 logs)
527
528 $docker_path logs $config
529 exit 0
530 ;;
531
532 restart)
533 run_stop
534 run_start
535 exit 0
536 ;;
537
538 start)
539 run_start
540 exit 0
541 ;;
542
543 rebuild)
544 if [ "$(git symbolic-ref --short HEAD)" == "master" ]; then
545 echo "Ensuring discourse docker is up to date"
546
547 git remote update
548
549 LOCAL=$(git rev-parse @)
550 REMOTE=$(git rev-parse @{u})
551 BASE=$(git merge-base @ @{u})
552
553 if [ $LOCAL = $REMOTE ]; then
554 echo "Discourse Docker is up-to-date"
555
556 elif [ $LOCAL = $BASE ]; then
557 echo "Updating Discourse Docker"
558 git pull || (echo 'failed to update' && exit 1)
559 exec /bin/bash $0 $@
560
561 elif [ $REMOTE = $BASE ]; then
562 echo "Your version of Discourse Docker is ahead of origin"
563
564 else
565 echo "Discourse Docker has diverged source, this is only expected in Dev mode"
566 fi
567
568 fi
569
570 set_existing_container
571
572 if [ ! -z $existing ]
573 then
574 echo "Stopping old container"
575 (
576 set -x
577 $docker_path stop -t 10 $config
578 )
579 fi
580
581 run_bootstrap
582
583 if [ ! -z $existing ]
584 then
585 echo "Removing old container"
586 (
587 set -x
588 $docker_path rm $config
589 )
590 fi
591
592 run_start
593 exit 0
594 ;;
595
596
597 destroy)
598 (set -x; $docker_path stop -t 10 $config && $docker_path rm $config) || (echo "$config was not found" && exit 0)
599 exit 0
600 ;;
601 esac
602
603 usage